--
-- BarraTraseira
--
-- @TMP
-- @31/05/2017

BarraTraseira = {};

BarraTraseira.modDir = g_currentModDirectory;

function BarraTraseira.prerequisitesPresent(specializations)
    return true; 
end;

function BarraTraseira:load(savegame)

    self.AnimacaoBarraTraseira = SpecializationUtil.callSpecializationsFunction("AnimacaoBarraTraseira"); 
    
    self.BarraTraseira = {};
    
    local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.BarraTraseira#trigger")) );
    if trigger == nil then
        print("[Erro: BarraTraseira] index ok, mas o trigger nas esta localizado. Volte a ver a linha "..tostring(i+1).." no seu xml");
    end;
    
    local TS = getXMLInt(self.xmlFile, string.format("vehicle.BarraTraseira#IC_Numero", i));
    
    self.BarraTraseira.TS = TS;
    self.BarraTraseira.trigger = trigger;
    self.BarraTraseira.TMP = false;
        
	addTrigger( trigger, "AnimacaoBarraTraseira", self );
    
end;

function BarraTraseira:delete()
    if self.BarraTraseira.trigger ~= nil then
        removeTrigger(self.BarraTraseira.trigger);
    end;
end;

function BarraTraseira:readStream(streamId, connection)
end;

function BarraTraseira:writeStream(streamId, connection)
end;

function BarraTraseira:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BarraTraseira:keyEvent(unicode, sym, modifier, isDown)
end;

function BarraTraseira:update(dt)
    
    if self.BarraTraseira.TMP then
        g_currentMission:addHelpButtonText( g_i18n:getText("BarraTraseira"), InputBinding.Aberturas );    
        setTextColor(1.0, 1.0, 1.0, 1.0);
        setTextAlignment(RenderText.ALIGN_CENTER);                 
        renderText( 0.53, 0.04, 0.035, g_i18n:getText("BarraTraseira") );
        if InputBinding.hasEvent(InputBinding.Aberturas)then
            local obj = self.interactiveObjects[self.BarraTraseira.TS];
            if obj ~= nil then
                self:doActionOnObject(self.BarraTraseira.TS);
            end;
        end
    end;
end;

function BarraTraseira:onLeave()
end;

function BarraTraseira:draw()
end;

function BarraTraseira:AnimacaoBarraTraseira(triggerId, otherId, onEnter, onLeave, onStay)
    
    if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.BarraTraseira.TMP = true;
    elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.BarraTraseira.TMP = false;
    end;
    
end;